=== debian/changelog ===
procdump (1.1.1-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Drop override_dh_auto_{build,install}. (Closes: #977480)

  [ Anuradha Weeraman]
  * Bumped up debhelper-compat version
  * Lintian fix for hardening-no-bindnow

 -- Anuradha Weeraman <anuradha@debian.org>  Tue, 29 Dec 2020 17:07:56 +0530

procdump (1.1.1-4) unstable; urgency=medium

  * Bumped up standards version
  * Forwarded patches upstream, lintian fix

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 09 Dec 2020 17:19:29 -0500

procdump (1.1.1-3) unstable; urgency=medium

  * Set the architecture to linux-any

 -- Anuradha Weeraman <anuradha@debian.org>  Fri, 24 Jul 2020 10:30:43 -0400

procdump (1.1.1-2) unstable; urgency=medium

  * Updated Vcs-* fields after moving to Debian group on Salsa
  * Reproducibility improvements
  * Fix FTBFS due to -fno-common default in GCC 10

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 22 Jul 2020 13:49:43 -0400

procdump (1.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #965243)

 -- Anuradha Weeraman <anuradha@debian.org>  Fri, 17 Jul 2020 23:39:40 -0400
