=== debian/control ===
Source: procdump
Section: utils
Priority: optional
Maintainer: Anuradha Weeraman <anuradha@debian.org>
Build-Depends: debhelper-compat (= 13), zlib1g-dev
Standards-Version: 4.5.1
Homepage: https://github.com/microsoft/ProcDump-for-Linux
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/procdump
Vcs-Git: https://salsa.debian.org/debian/procdump.git

Package: procdump
Architecture: linux-any
Suggests: gdb
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Utility to create core dumps based on performance triggers
 ProcDump provides a convenient way for Linux developers to create core
 dumps of their application based on performance triggers.
