=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath
DPKG_EXPORT_BUILDFLAGS=1

include /usr/share/dpkg/buildflags.mk

# GCC10 defaults to -fno-common.
# Resolving FTBFS with -fcommon: https://gcc.gnu.org/gcc-10/porting_to.html
export CFLAGS+=$(shell dpkg-buildflags --get CFLAGS) -fcommon -Wl,-z,now
export CFLAGS+=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS+=$(shell dpkg-buildflags --get LDFLAGS)
export LC_ALL=C

%:
	dh $@

override_dh_auto_test:
