=== debian/watch ===
version=4
https://github.com/microsoft/ProcDump-for-Linux/tags .*/?(\d\.\d.\d)\.tar\.gz
