## procdump 1.2

=== Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 			$(BUILDDIR)/SOURCES $(BUILDDIR)/SPECS $(BUILDDIR)/BUILD $(BUILDDIR)/BUILDROOT
 
 # package details
-PKG_VERSION=1.1.1
+PKG_VERSION=1.2
 
 all: clean build
