=== debian/changelog ===
procdump (1.2-4) unstable; urgency=medium

  * Bumped up standards version.

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 28 Jan 2023 22:28:48 +0530

procdump (1.2-3) unstable; urgency=medium

  * Bumped up standards version.

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 10 Sep 2022 14:20:51 +0530

procdump (1.2-2) unstable; urgency=high

  * Fix FTBFS with parallel builds (Closes: #994586)

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 18 Sep 2021 13:12:11 +0530

procdump (1.2-1) unstable; urgency=high

  * New upstream release
  * Updated debian patches

 -- Anuradha Weeraman <anuradha@debian.org>  Fri, 17 Sep 2021 23:12:05 +0530

procdump (1.1.1-6) unstable; urgency=high

  * Bumped up Standards Version
  * Added autopkgtest
  * Added dependency on gdb

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 08 Sep 2021 21:38:00 +0530
