=== debian/changelog ===
procdump (2.2-4) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Add patch to fix arm* builds
  * Add patch to fix 32bit builds

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Mar 2025 20:28:01 +0100

procdump (2.2-3) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Fix build with new make failing to parse tabs in Makefile
    This should print correctly the architecture now result of
    "uname -p", and let us fix build failures accordingly

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Mar 2025 10:33:35 +0100

procdump (2.2-2) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace).

  [ Benjamin Drung <bdrung@ubuntu.com> ]
  * Cherry-pick 2 upstream commits to fix build failure (LP: #2067602)
    (Closes: #1064137)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Mar 2025 20:44:59 +0100

procdump (2.2-1) unstable; urgency=high

  * New upstream release.
  * NEWS file on breaking changes to the CLI.
  * Bumped up standards version.
  * Several lintian fixes.

 -- Anuradha Weeraman <anuradha@debian.org>  Sun, 15 Oct 2023 20:05:20 +0530
