=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/procdump_$1\.tar\.gz/" \
  https://github.com/Sysinternals/ProcDump-for-Linux/tags .*/v?(\d\S+)\.tar\.gz
