=== debian/changelog ===
procdump (3.4.1-1~exp4) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * B-D on bpftool/bpftrace

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 15:13:02 +0200

procdump (3.4.1-1~exp3) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Add support for system libbpf from github proposed PR #266

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 11:37:53 +0200

procdump (3.4.1-1~exp2) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Add cmake to B-D

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 11:26:43 +0200

procdump (3.4.1-1~exp1) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * New upstream version 3.4.1
  * Update copyright file for new release
  * Add patch to fix mips64el, uncommitted to series file
  * Drop upstream patches, cherry-pick merged 273 PR on top

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 11:16:29 +0200
