=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Anuradha Weeraman <anuradha@debian.org>
-Build-Depends: debhelper-compat (= 13), zlib1g-dev, clang
+Build-Depends: debhelper-compat (= 13), zlib1g-dev, bpftrace, bpftool, libbpf-dev, cmake, clang
 Standards-Version: 4.6.2
 Homepage: https://github.com/microsoft/ProcDump-for-Linux
 Rules-Requires-Root: no
