=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath
-DPKG_EXPORT_BUILDFLAGS=1
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+all buildinfo=+path
+export DPKG_EXPORT_BUILDFLAGS=1
 
 include /usr/share/dpkg/buildflags.mk
