=== debian/tests/control ===
Tests: run.sh
Depends: procdump, procps
Restrictions: needs-root
